/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AccreditationModel } from '../models';
import { AccreditationsModel } from '../models';
import { CreateAccreditationCommand } from '../models';
import { UpdateAccreditationCommand } from '../models';
/**
 * AccreditationsApi - axios parameter creator
 * @export
 */
export declare const AccreditationsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdDelete: (accreditationId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Accreditation. (Auth policies: RequireLocalManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdGet: (accreditationId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {UpdateAccreditationCommand} [updateAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdPut: (accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all Accreditations. (Auth policies: RequireLocalManagerRole)
     * @param {string} [name]
     * @param {string} [logo]
     * @param {string} [country]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsGet: (name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a Accreditation. (Auth policies: RequireManagerRole)
     * @param {CreateAccreditationCommand} [createAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsPost: (createAccreditationCommand?: CreateAccreditationCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * AccreditationsApi - functional programming interface
 * @export
 */
export declare const AccreditationsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdDelete(accreditationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Accreditation. (Auth policies: RequireLocalManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdGet(accreditationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>>;
    /**
     *
     * @summary Update Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {UpdateAccreditationCommand} [updateAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdPut(accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>>;
    /**
     *
     * @summary Get all Accreditations. (Auth policies: RequireLocalManagerRole)
     * @param {string} [name]
     * @param {string} [logo]
     * @param {string} [country]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsGet(name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationsModel>>;
    /**
     *
     * @summary Create a Accreditation. (Auth policies: RequireManagerRole)
     * @param {CreateAccreditationCommand} [createAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsPost(createAccreditationCommand?: CreateAccreditationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>>;
};
/**
 * AccreditationsApi - factory interface
 * @export
 */
export declare const AccreditationsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdDelete(accreditationId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Accreditation. (Auth policies: RequireLocalManagerRole)
     * @param {string} accreditationId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdGet(accreditationId: string, options?: any): AxiosPromise<AccreditationModel>;
    /**
     *
     * @summary Update Accreditation. (Auth policies: RequireManagerRole)
     * @param {string} accreditationId
     * @param {UpdateAccreditationCommand} [updateAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsAccreditationIdPut(accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options?: any): AxiosPromise<AccreditationModel>;
    /**
     *
     * @summary Get all Accreditations. (Auth policies: RequireLocalManagerRole)
     * @param {string} [name]
     * @param {string} [logo]
     * @param {string} [country]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsGet(name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AccreditationsModel>;
    /**
     *
     * @summary Create a Accreditation. (Auth policies: RequireManagerRole)
     * @param {CreateAccreditationCommand} [createAccreditationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AccreditationsPost(createAccreditationCommand?: CreateAccreditationCommand, options?: any): AxiosPromise<AccreditationModel>;
};
/**
 * Request parameters for apiV1AccreditationsAccreditationIdDelete operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdDelete
     */
    readonly accreditationId: string;
}
/**
 * Request parameters for apiV1AccreditationsAccreditationIdGet operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdGet
     */
    readonly accreditationId: string;
}
/**
 * Request parameters for apiV1AccreditationsAccreditationIdPut operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdPut
     */
    readonly accreditationId: string;
    /**
     *
     * @type {UpdateAccreditationCommand}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdPut
     */
    readonly updateAccreditationCommand?: UpdateAccreditationCommand;
}
/**
 * Request parameters for apiV1AccreditationsGet operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsGetRequest
 */
export interface AccreditationsApiApiV1AccreditationsGetRequest {
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly logo?: string;
    /**
     *
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly country?: string;
    /**
     *
     * @type {number}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1AccreditationsPost operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsPostRequest
 */
export interface AccreditationsApiApiV1AccreditationsPostRequest {
    /**
     *
     * @type {CreateAccreditationCommand}
     * @memberof AccreditationsApiApiV1AccreditationsPost
     */
    readonly createAccreditationCommand?: CreateAccreditationCommand;
}
/**
 * AccreditationsApi - object-oriented interface
 * @export
 * @class AccreditationsApi
 * @extends {BaseAPI}
 */
export declare class AccreditationsApi extends BaseAPI {
    /**
     *
     * @summary Delete Accreditation. (Auth policies: RequireManagerRole)
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    apiV1AccreditationsAccreditationIdDelete(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Accreditation. (Auth policies: RequireLocalManagerRole)
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    apiV1AccreditationsAccreditationIdGet(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AccreditationModel, any>>;
    /**
     *
     * @summary Update Accreditation. (Auth policies: RequireManagerRole)
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    apiV1AccreditationsAccreditationIdPut(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AccreditationModel, any>>;
    /**
     *
     * @summary Get all Accreditations. (Auth policies: RequireLocalManagerRole)
     * @param {AccreditationsApiApiV1AccreditationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    apiV1AccreditationsGet(requestParameters?: AccreditationsApiApiV1AccreditationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AccreditationsModel, any>>;
    /**
     *
     * @summary Create a Accreditation. (Auth policies: RequireManagerRole)
     * @param {AccreditationsApiApiV1AccreditationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    apiV1AccreditationsPost(requestParameters?: AccreditationsApiApiV1AccreditationsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AccreditationModel, any>>;
}
//# sourceMappingURL=accreditations-api.d.ts.map