/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CHManagerModel } from '../models';
import { CHManagersModel } from '../models';
import { CreateCHManagerCommand } from '../models';
import { Gender } from '../models';
import { UpdateCHManagerCommand } from '../models';
/**
 * CHManagersApi - axios parameter creator
 * @export
 */
export declare const CHManagersApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdDelete: (cHManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get CHManager. (Auth policies: RequireManagerRole)
     * @param {string} cHManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdGet: (cHManagerId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {UpdateCHManagerCommand} [updateCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdPut: (cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all CHManagers. (Auth policies: RequireAdministratorRole)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersGet: (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CreateCHManagerCommand} [createCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersPost: (createCHManagerCommand?: CreateCHManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CHManagersApi - functional programming interface
 * @export
 */
export declare const CHManagersApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdDelete(cHManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get CHManager. (Auth policies: RequireManagerRole)
     * @param {string} cHManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdGet(cHManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>>;
    /**
     *
     * @summary Update CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {UpdateCHManagerCommand} [updateCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdPut(cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>>;
    /**
     *
     * @summary Get all CHManagers. (Auth policies: RequireAdministratorRole)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagersModel>>;
    /**
     *
     * @summary Create a CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CreateCHManagerCommand} [createCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersPost(createCHManagerCommand?: CreateCHManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>>;
};
/**
 * CHManagersApi - factory interface
 * @export
 */
export declare const CHManagersApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdDelete(cHManagerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get CHManager. (Auth policies: RequireManagerRole)
     * @param {string} cHManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdGet(cHManagerId: string, options?: any): AxiosPromise<CHManagerModel>;
    /**
     *
     * @summary Update CHManager. (Auth policies: RequireAdministratorRole)
     * @param {string} cHManagerId
     * @param {UpdateCHManagerCommand} [updateCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersCHManagerIdPut(cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options?: any): AxiosPromise<CHManagerModel>;
    /**
     *
     * @summary Get all CHManagers. (Auth policies: RequireAdministratorRole)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CHManagersModel>;
    /**
     *
     * @summary Create a CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CreateCHManagerCommand} [createCHManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ChmanagersPost(createCHManagerCommand?: CreateCHManagerCommand, options?: any): AxiosPromise<CHManagerModel>;
};
/**
 * Request parameters for apiV1ChmanagersCHManagerIdDelete operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdDelete
     */
    readonly cHManagerId: string;
    /**
     *
     * @type {boolean}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1ChmanagersCHManagerIdGet operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdGetRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdGet
     */
    readonly cHManagerId: string;
}
/**
 * Request parameters for apiV1ChmanagersCHManagerIdPut operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdPutRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdPut
     */
    readonly cHManagerId: string;
    /**
     *
     * @type {UpdateCHManagerCommand}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdPut
     */
    readonly updateCHManagerCommand?: UpdateCHManagerCommand;
}
/**
 * Request parameters for apiV1ChmanagersGet operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersGetRequest
 */
export interface CHManagersApiApiV1ChmanagersGetRequest {
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly fullname?: string;
    /**
     *
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly email?: string;
    /**
     *
     * @type {Gender}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly gender?: Gender;
    /**
     *
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly dateOfBirth?: Date;
    /**
     *
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly created?: Date;
    /**
     *
     * @type {boolean}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ChmanagersPost operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersPostRequest
 */
export interface CHManagersApiApiV1ChmanagersPostRequest {
    /**
     *
     * @type {CreateCHManagerCommand}
     * @memberof CHManagersApiApiV1ChmanagersPost
     */
    readonly createCHManagerCommand?: CreateCHManagerCommand;
}
/**
 * CHManagersApi - object-oriented interface
 * @export
 * @class CHManagersApi
 * @extends {BaseAPI}
 */
export declare class CHManagersApi extends BaseAPI {
    /**
     *
     * @summary Delete CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    apiV1ChmanagersCHManagerIdDelete(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get CHManager. (Auth policies: RequireManagerRole)
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    apiV1ChmanagersCHManagerIdGet(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CHManagerModel, any>>;
    /**
     *
     * @summary Update CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    apiV1ChmanagersCHManagerIdPut(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CHManagerModel, any>>;
    /**
     *
     * @summary Get all CHManagers. (Auth policies: RequireAdministratorRole)
     * @param {CHManagersApiApiV1ChmanagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    apiV1ChmanagersGet(requestParameters?: CHManagersApiApiV1ChmanagersGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CHManagersModel, any>>;
    /**
     *
     * @summary Create a CHManager. (Auth policies: RequireAdministratorRole)
     * @param {CHManagersApiApiV1ChmanagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    apiV1ChmanagersPost(requestParameters?: CHManagersApiApiV1ChmanagersPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CHManagerModel, any>>;
}
//# sourceMappingURL=chmanagers-api.d.ts.map