/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CommunicationUserTokenModel } from '../models';
/**
 * CommunicationsApi - axios parameter creator
 * @export
 */
export declare const CommunicationsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsDelete: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get CommunicationUser. (Auth policies: RequireDefaultAdminAppRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsGet: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revoke CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsPut: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CommunicationsApi - functional programming interface
 * @export
 */
export declare const CommunicationsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsDelete(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<number>>;
    /**
     *
     * @summary Get CommunicationUser. (Auth policies: RequireDefaultAdminAppRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CommunicationUserTokenModel>>;
    /**
     *
     * @summary Revoke CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsPut(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CommunicationUserTokenModel>>;
};
/**
 * CommunicationsApi - factory interface
 * @export
 */
export declare const CommunicationsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsDelete(options?: any): AxiosPromise<number>;
    /**
     *
     * @summary Get CommunicationUser. (Auth policies: RequireDefaultAdminAppRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsGet(options?: any): AxiosPromise<CommunicationUserTokenModel>;
    /**
     *
     * @summary Revoke CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CommunicationsPut(options?: any): AxiosPromise<CommunicationUserTokenModel>;
};
/**
 * CommunicationsApi - object-oriented interface
 * @export
 * @class CommunicationsApi
 * @extends {BaseAPI}
 */
export declare class CommunicationsApi extends BaseAPI {
    /**
     *
     * @summary Delete CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    apiV1CommunicationsDelete(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<number, any>>;
    /**
     *
     * @summary Get CommunicationUser. (Auth policies: RequireDefaultAdminAppRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    apiV1CommunicationsGet(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CommunicationUserTokenModel, any>>;
    /**
     *
     * @summary Revoke CommunicationUser. (Auth policies: RequireLocalManagerRole)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CommunicationsApi
     */
    apiV1CommunicationsPut(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CommunicationUserTokenModel, any>>;
}
//# sourceMappingURL=communications-api.d.ts.map