/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { ContributorModel } from '../models';
import { ContributorSnsHandlesModel } from '../models';
import { ContributorsModel } from '../models';
import { CreateContributorCommand } from '../models';
import { CreateContributorSnsHandleCommand } from '../models';
import { SnsHandleModel } from '../models';
import { SnsType } from '../models';
import { UpdateContributorCommand } from '../models';
import { UpdateContributorSnsHandleCommand } from '../models';
/**
 * ContributorsApi - axios parameter creator
 * @export
 */
export declare const ContributorsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdDelete: (contributorId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Contributor. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} contributorId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdGet: (contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all ContributorHandles. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} [id]
     * @param {SnsType} [snsType]
     * @param {string} [handle]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesGet: (contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdDelete: (contributorId: string, handleId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdGet: (contributorId: string, handleId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdPut: (contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesPost: (contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {UpdateContributorCommand} [updateContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdPut: (contributorId: string, updateContributorCommand?: UpdateContributorCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate countributor (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdRevalidatePost: (contributorId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all Contributors. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [website]
     * @param {string} [hospitalId]
     * @param {boolean} [interviewerOnly]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsGet: (id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {CreateContributorCommand} [createContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsPost: (createContributorCommand?: CreateContributorCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Contributor by slug. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ContributorsApi - functional programming interface
 * @export
 */
export declare const ContributorsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdDelete(contributorId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Contributor. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} contributorId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdGet(contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>>;
    /**
     *
     * @summary Get all ContributorHandles. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} [id]
     * @param {SnsType} [snsType]
     * @param {string} [handle]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesGet(contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorSnsHandlesModel>>;
    /**
     *
     * @summary Delete ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId: string, handleId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId: string, handleId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>>;
    /**
     *
     * @summary Update ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesPost(contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>>;
    /**
     *
     * @summary Update Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {UpdateContributorCommand} [updateContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdPut(contributorId: string, updateContributorCommand?: UpdateContributorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>>;
    /**
     *
     * @summary Revalidate countributor (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdRevalidatePost(contributorId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all Contributors. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [website]
     * @param {string} [hospitalId]
     * @param {boolean} [interviewerOnly]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsGet(id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorsModel>>;
    /**
     *
     * @summary Create a Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {CreateContributorCommand} [createContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsPost(createContributorCommand?: CreateContributorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>>;
    /**
     *
     * @summary Get Contributor by slug. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>>;
};
/**
 * ContributorsApi - factory interface
 * @export
 */
export declare const ContributorsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdDelete(contributorId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Contributor. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} contributorId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdGet(contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<ContributorModel>;
    /**
     *
     * @summary Get all ContributorHandles. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} [id]
     * @param {SnsType} [snsType]
     * @param {string} [handle]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesGet(contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ContributorSnsHandlesModel>;
    /**
     *
     * @summary Delete ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId: string, handleId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId: string, handleId: string, options?: any): AxiosPromise<SnsHandleModel>;
    /**
     *
     * @summary Update ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {string} handleId
     * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options?: any): AxiosPromise<SnsHandleModel>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdHandlesPost(contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options?: any): AxiosPromise<SnsHandleModel>;
    /**
     *
     * @summary Update Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {UpdateContributorCommand} [updateContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdPut(contributorId: string, updateContributorCommand?: UpdateContributorCommand, options?: any): AxiosPromise<ContributorModel>;
    /**
     *
     * @summary Revalidate countributor (Auth policies: RequireLocalManagerRole)
     * @param {string} contributorId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsContributorIdRevalidatePost(contributorId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all Contributors. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [website]
     * @param {string} [hospitalId]
     * @param {boolean} [interviewerOnly]
     * @param {boolean} [showHidden]
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsGet(id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ContributorsModel>;
    /**
     *
     * @summary Create a Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {CreateContributorCommand} [createContributorCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsPost(createContributorCommand?: CreateContributorCommand, options?: any): AxiosPromise<ContributorModel>;
    /**
     *
     * @summary Get Contributor by slug. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ContributorsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<ContributorModel>;
};
/**
 * Request parameters for apiV1ContributorsContributorIdDelete operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdDeleteRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdDelete
     */
    readonly contributorId: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1ContributorsContributorIdGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly contributorId: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1ContributorsContributorIdHandlesGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly contributorId: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly id?: string;
    /**
     *
     * @type {SnsType}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly snsType?: SnsType;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly handle?: string;
    /**
     *
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdDelete operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDelete
     */
    readonly contributorId: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDelete
     */
    readonly handleId: string;
}
/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGet
     */
    readonly contributorId: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGet
     */
    readonly handleId: string;
}
/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdPut operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly contributorId: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly handleId: string;
    /**
     *
     * @type {UpdateContributorSnsHandleCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand;
}
/**
 * Request parameters for apiV1ContributorsContributorIdHandlesPost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesPost
     */
    readonly contributorId: string;
    /**
     *
     * @type {CreateContributorSnsHandleCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesPost
     */
    readonly createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand;
}
/**
 * Request parameters for apiV1ContributorsContributorIdPut operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdPutRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdPut
     */
    readonly contributorId: string;
    /**
     *
     * @type {UpdateContributorCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdPut
     */
    readonly updateContributorCommand?: UpdateContributorCommand;
}
/**
 * Request parameters for apiV1ContributorsContributorIdRevalidatePost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdRevalidatePost
     */
    readonly contributorId: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1ContributorsGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsGetRequest
 */
export interface ContributorsApiApiV1ContributorsGetRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly email?: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly website?: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly interviewerOnly?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ContributorsPost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsPostRequest
 */
export interface ContributorsApiApiV1ContributorsPostRequest {
    /**
     *
     * @type {CreateContributorCommand}
     * @memberof ContributorsApiApiV1ContributorsPost
     */
    readonly createContributorCommand?: CreateContributorCommand;
}
/**
 * Request parameters for apiV1ContributorsSlugGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsSlugGetRequest
 */
export interface ContributorsApiApiV1ContributorsSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * ContributorsApi - object-oriented interface
 * @export
 * @class ContributorsApi
 * @extends {BaseAPI}
 */
export declare class ContributorsApi extends BaseAPI {
    /**
     *
     * @summary Delete Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdDelete(requestParameters: ContributorsApiApiV1ContributorsContributorIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Contributor. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorModel, any>>;
    /**
     *
     * @summary Get all ContributorHandles. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdHandlesGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorSnsHandlesModel, any>>;
    /**
     *
     * @summary Delete ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdHandlesHandleIdDelete(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdHandlesHandleIdGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SnsHandleModel, any>>;
    /**
     *
     * @summary Update ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdHandlesHandleIdPut(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SnsHandleModel, any>>;
    /**
     *
     * @summary Get ContributorHandle. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdHandlesPost(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SnsHandleModel, any>>;
    /**
     *
     * @summary Update Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdPut(requestParameters: ContributorsApiApiV1ContributorsContributorIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorModel, any>>;
    /**
     *
     * @summary Revalidate countributor (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsContributorIdRevalidatePost(requestParameters: ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all Contributors. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {ContributorsApiApiV1ContributorsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsGet(requestParameters?: ContributorsApiApiV1ContributorsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorsModel, any>>;
    /**
     *
     * @summary Create a Contributor. (Auth policies: RequireLocalManagerRole)
     * @param {ContributorsApiApiV1ContributorsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsPost(requestParameters?: ContributorsApiApiV1ContributorsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorModel, any>>;
    /**
     *
     * @summary Get Contributor by slug. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {ContributorsApiApiV1ContributorsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    apiV1ContributorsSlugGet(requestParameters: ContributorsApiApiV1ContributorsSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ContributorModel, any>>;
}
//# sourceMappingURL=contributors-api.d.ts.map