/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateCurrencyCommand } from '../models';
import { CurrenciesModel } from '../models';
import { CurrencyModel } from '../models';
import { SortCurrenciesCommand } from '../models';
import { UpdateCurrencyCommand } from '../models';
/**
 * CurrenciesApi - axios parameter creator
 * @export
 */
export declare const CurrenciesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdDelete: (currencyId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get currency (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdGet: (currencyId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {UpdateCurrencyCommand} [updateCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdPut: (currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdReactivatePut: (currencyId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get currencies (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} [id]
     * @param {string} [currencyCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesGet: (id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create currency (Auth policies: RequireManagerRole)
     * @param {CreateCurrencyCommand} [createCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesPost: (createCurrencyCommand?: CreateCurrencyCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Sort currencies (Auth policies: RequireManagerRole)
     * @param {SortCurrenciesCommand} [sortCurrenciesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesSortPut: (sortCurrenciesCommand?: SortCurrenciesCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CurrenciesApi - functional programming interface
 * @export
 */
export declare const CurrenciesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdDelete(currencyId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get currency (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdGet(currencyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>>;
    /**
     *
     * @summary Update currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {UpdateCurrencyCommand} [updateCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdPut(currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>>;
    /**
     *
     * @summary Reactivate currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdReactivatePut(currencyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get currencies (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} [id]
     * @param {string} [currencyCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesGet(id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrenciesModel>>;
    /**
     *
     * @summary Create currency (Auth policies: RequireManagerRole)
     * @param {CreateCurrencyCommand} [createCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesPost(createCurrencyCommand?: CreateCurrencyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>>;
    /**
     *
     * @summary Sort currencies (Auth policies: RequireManagerRole)
     * @param {SortCurrenciesCommand} [sortCurrenciesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesSortPut(sortCurrenciesCommand?: SortCurrenciesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
};
/**
 * CurrenciesApi - factory interface
 * @export
 */
export declare const CurrenciesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdDelete(currencyId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get currency (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdGet(currencyId: string, options?: any): AxiosPromise<CurrencyModel>;
    /**
     *
     * @summary Update currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {UpdateCurrencyCommand} [updateCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdPut(currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options?: any): AxiosPromise<CurrencyModel>;
    /**
     *
     * @summary Reactivate currency (Auth policies: RequireManagerRole)
     * @param {string} currencyId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesCurrencyIdReactivatePut(currencyId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get currencies (Auth policies: RequireDefaultAdminAppRole)
     * @param {string} [id]
     * @param {string} [currencyCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesGet(id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CurrenciesModel>;
    /**
     *
     * @summary Create currency (Auth policies: RequireManagerRole)
     * @param {CreateCurrencyCommand} [createCurrencyCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesPost(createCurrencyCommand?: CreateCurrencyCommand, options?: any): AxiosPromise<CurrencyModel>;
    /**
     *
     * @summary Sort currencies (Auth policies: RequireManagerRole)
     * @param {SortCurrenciesCommand} [sortCurrenciesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1CurrenciesSortPut(sortCurrenciesCommand?: SortCurrenciesCommand, options?: any): AxiosPromise<boolean>;
};
/**
 * Request parameters for apiV1CurrenciesCurrencyIdDelete operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdDelete
     */
    readonly currencyId: string;
    /**
     *
     * @type {boolean}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1CurrenciesCurrencyIdGet operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdGet
     */
    readonly currencyId: string;
}
/**
 * Request parameters for apiV1CurrenciesCurrencyIdPut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdPut
     */
    readonly currencyId: string;
    /**
     *
     * @type {UpdateCurrencyCommand}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdPut
     */
    readonly updateCurrencyCommand?: UpdateCurrencyCommand;
}
/**
 * Request parameters for apiV1CurrenciesCurrencyIdReactivatePut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePut
     */
    readonly currencyId: string;
}
/**
 * Request parameters for apiV1CurrenciesGet operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesGetRequest
 */
export interface CurrenciesApiApiV1CurrenciesGetRequest {
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly currencyCode?: string;
    /**
     *
     * @type {number}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1CurrenciesPost operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesPostRequest
 */
export interface CurrenciesApiApiV1CurrenciesPostRequest {
    /**
     *
     * @type {CreateCurrencyCommand}
     * @memberof CurrenciesApiApiV1CurrenciesPost
     */
    readonly createCurrencyCommand?: CreateCurrencyCommand;
}
/**
 * Request parameters for apiV1CurrenciesSortPut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesSortPutRequest
 */
export interface CurrenciesApiApiV1CurrenciesSortPutRequest {
    /**
     *
     * @type {SortCurrenciesCommand}
     * @memberof CurrenciesApiApiV1CurrenciesSortPut
     */
    readonly sortCurrenciesCommand?: SortCurrenciesCommand;
}
/**
 * CurrenciesApi - object-oriented interface
 * @export
 * @class CurrenciesApi
 * @extends {BaseAPI}
 */
export declare class CurrenciesApi extends BaseAPI {
    /**
     *
     * @summary Delete currency (Auth policies: RequireManagerRole)
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesCurrencyIdDelete(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get currency (Auth policies: RequireDefaultAdminAppRole)
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesCurrencyIdGet(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurrencyModel, any>>;
    /**
     *
     * @summary Update currency (Auth policies: RequireManagerRole)
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesCurrencyIdPut(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurrencyModel, any>>;
    /**
     *
     * @summary Reactivate currency (Auth policies: RequireManagerRole)
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesCurrencyIdReactivatePut(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get currencies (Auth policies: RequireDefaultAdminAppRole)
     * @param {CurrenciesApiApiV1CurrenciesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesGet(requestParameters?: CurrenciesApiApiV1CurrenciesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurrenciesModel, any>>;
    /**
     *
     * @summary Create currency (Auth policies: RequireManagerRole)
     * @param {CurrenciesApiApiV1CurrenciesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesPost(requestParameters?: CurrenciesApiApiV1CurrenciesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CurrencyModel, any>>;
    /**
     *
     * @summary Sort currencies (Auth policies: RequireManagerRole)
     * @param {CurrenciesApiApiV1CurrenciesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    apiV1CurrenciesSortPut(requestParameters?: CurrenciesApiApiV1CurrenciesSortPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
}
//# sourceMappingURL=currencies-api.d.ts.map