/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AppointmentStatisticsModel } from '../models';
import { CallStatisticsModel } from '../models';
import { DashBoardModel } from '../models';
import { Duration } from '../models';
import { GeneralStatisticsModel } from '../models';
import { SurveyFormStatisticsModel } from '../models';
/**
 * DashBoardApi - axios parameter creator
 * @export
 */
export declare const DashBoardApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get appointment statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardAppointmentGet: (duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get call statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardCallGet: (duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get general statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGeneralGet: (duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get intergrated dashboard data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGet: (duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get survey form statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardSurveyformGet: (duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DashBoardApi - functional programming interface
 * @export
 */
export declare const DashBoardApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get appointment statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardAppointmentGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentStatisticsModel>>;
    /**
     *
     * @summary Get call statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardCallGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CallStatisticsModel>>;
    /**
     *
     * @summary Get general statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGeneralGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralStatisticsModel>>;
    /**
     *
     * @summary Get intergrated dashboard data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DashBoardModel>>;
    /**
     *
     * @summary Get survey form statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardSurveyformGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormStatisticsModel>>;
};
/**
 * DashBoardApi - factory interface
 * @export
 */
export declare const DashBoardApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get appointment statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardAppointmentGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<AppointmentStatisticsModel>;
    /**
     *
     * @summary Get call statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardCallGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<CallStatisticsModel>;
    /**
     *
     * @summary Get general statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGeneralGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<GeneralStatisticsModel>;
    /**
     *
     * @summary Get intergrated dashboard data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<DashBoardModel>;
    /**
     *
     * @summary Get survey form statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {Duration} duration
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DashboardSurveyformGet(duration: Duration, hospitalId?: string, languageCode?: string, options?: any): AxiosPromise<SurveyFormStatisticsModel>;
};
/**
 * Request parameters for apiV1DashboardAppointmentGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardAppointmentGetRequest
 */
export interface DashBoardApiApiV1DashboardAppointmentGetRequest {
    /**
     *
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly duration: Duration;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardAppointmentGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DashboardCallGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardCallGetRequest
 */
export interface DashBoardApiApiV1DashboardCallGetRequest {
    /**
     *
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly duration: Duration;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardCallGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DashboardGeneralGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardGeneralGetRequest
 */
export interface DashBoardApiApiV1DashboardGeneralGetRequest {
    /**
     *
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly duration: Duration;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGeneralGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DashboardGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardGetRequest
 */
export interface DashBoardApiApiV1DashboardGetRequest {
    /**
     *
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly duration: Duration;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DashboardSurveyformGet operation in DashBoardApi.
 * @export
 * @interface DashBoardApiApiV1DashboardSurveyformGetRequest
 */
export interface DashBoardApiApiV1DashboardSurveyformGetRequest {
    /**
     *
     * @type {Duration}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly duration: Duration;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DashBoardApiApiV1DashboardSurveyformGet
     */
    readonly languageCode?: string;
}
/**
 * DashBoardApi - object-oriented interface
 * @export
 * @class DashBoardApi
 * @extends {BaseAPI}
 */
export declare class DashBoardApi extends BaseAPI {
    /**
     *
     * @summary Get appointment statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {DashBoardApiApiV1DashboardAppointmentGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    apiV1DashboardAppointmentGet(requestParameters: DashBoardApiApiV1DashboardAppointmentGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AppointmentStatisticsModel, any>>;
    /**
     *
     * @summary Get call statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {DashBoardApiApiV1DashboardCallGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    apiV1DashboardCallGet(requestParameters: DashBoardApiApiV1DashboardCallGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<CallStatisticsModel, any>>;
    /**
     *
     * @summary Get general statistics data (Auth policies: RequireDefaultAdminAppRole)
     * @param {DashBoardApiApiV1DashboardGeneralGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    apiV1DashboardGeneralGet(requestParameters: DashBoardApiApiV1DashboardGeneralGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GeneralStatisticsModel, any>>;
    /**
     *
     * @summary Get intergrated dashboard data (Auth policies: RequireDefaultAdminAppRole)
     * @param {DashBoardApiApiV1DashboardGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    apiV1DashboardGet(requestParameters: DashBoardApiApiV1DashboardGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DashBoardModel, any>>;
    /**
     *
     * @summary Get survey form statisticss data (Auth policies: RequireDefaultAdminAppRole)
     * @param {DashBoardApiApiV1DashboardSurveyformGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DashBoardApi
     */
    apiV1DashboardSurveyformGet(requestParameters: DashBoardApiApiV1DashboardSurveyformGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormStatisticsModel, any>>;
}
//# sourceMappingURL=dash-board-api.d.ts.map