/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { EmailRecordModel } from '../models';
import { EmailRecordsModel } from '../models';
import { EmailStatus } from '../models';
import { TestEmailModel } from '../models';
import { TestEmailWebhookCommand } from '../models';
/**
 * EmailWebhooksApi - axios parameter creator
 * @export
 */
export declare const EmailWebhooksApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Receive email webhooks events
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksInboundPost: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get email records. (from an week ago as default) (Auth policies: RequireDoctorRole)
     * @param {Date} [createdFrom]
     * @param {Date} [createdTo]
     * @param {Date} [updatedFrom]
     * @param {Date} [updatedTo]
     * @param {string} [senderName]
     * @param {string} [senderEmail]
     * @param {string} [recipientName]
     * @param {string} [recipientEmail]
     * @param {Array<EmailStatus>} [statuses]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsGet: (createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get email record by id with events. (Auth policies: RequireDoctorRole)
     * @param {string} recordId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsRecordIdGet: (recordId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Sending test email that follows email webhook steps. (Auth policies: RequireDoctorRole)
     * @param {TestEmailWebhookCommand} [testEmailWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksTestPost: (testEmailWebhookCommand?: TestEmailWebhookCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * EmailWebhooksApi - functional programming interface
 * @export
 */
export declare const EmailWebhooksApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Receive email webhooks events
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksInboundPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>>;
    /**
     *
     * @summary Get email records. (from an week ago as default) (Auth policies: RequireDoctorRole)
     * @param {Date} [createdFrom]
     * @param {Date} [createdTo]
     * @param {Date} [updatedFrom]
     * @param {Date} [updatedTo]
     * @param {string} [senderName]
     * @param {string} [senderEmail]
     * @param {string} [recipientName]
     * @param {string} [recipientEmail]
     * @param {Array<EmailStatus>} [statuses]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsGet(createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EmailRecordsModel>>;
    /**
     *
     * @summary Get email record by id with events. (Auth policies: RequireDoctorRole)
     * @param {string} recordId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsRecordIdGet(recordId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EmailRecordModel>>;
    /**
     *
     * @summary Sending test email that follows email webhook steps. (Auth policies: RequireDoctorRole)
     * @param {TestEmailWebhookCommand} [testEmailWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksTestPost(testEmailWebhookCommand?: TestEmailWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TestEmailModel>>;
};
/**
 * EmailWebhooksApi - factory interface
 * @export
 */
export declare const EmailWebhooksApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Receive email webhooks events
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksInboundPost(options?: any): AxiosPromise<object>;
    /**
     *
     * @summary Get email records. (from an week ago as default) (Auth policies: RequireDoctorRole)
     * @param {Date} [createdFrom]
     * @param {Date} [createdTo]
     * @param {Date} [updatedFrom]
     * @param {Date} [updatedTo]
     * @param {string} [senderName]
     * @param {string} [senderEmail]
     * @param {string} [recipientName]
     * @param {string} [recipientEmail]
     * @param {Array<EmailStatus>} [statuses]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsGet(createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<EmailRecordsModel>;
    /**
     *
     * @summary Get email record by id with events. (Auth policies: RequireDoctorRole)
     * @param {string} recordId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksRecordsRecordIdGet(recordId: string, options?: any): AxiosPromise<EmailRecordModel>;
    /**
     *
     * @summary Sending test email that follows email webhook steps. (Auth policies: RequireDoctorRole)
     * @param {TestEmailWebhookCommand} [testEmailWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1EmailwebhooksTestPost(testEmailWebhookCommand?: TestEmailWebhookCommand, options?: any): AxiosPromise<TestEmailModel>;
};
/**
 * Request parameters for apiV1EmailwebhooksRecordsGet operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest {
    /**
     *
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly createdFrom?: Date;
    /**
     *
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly createdTo?: Date;
    /**
     *
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly updatedFrom?: Date;
    /**
     *
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly updatedTo?: Date;
    /**
     *
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly senderName?: string;
    /**
     *
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly senderEmail?: string;
    /**
     *
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly recipientName?: string;
    /**
     *
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly recipientEmail?: string;
    /**
     *
     * @type {Array<EmailStatus>}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly statuses?: Array<EmailStatus>;
    /**
     *
     * @type {number}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1EmailwebhooksRecordsRecordIdGet operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGet
     */
    readonly recordId: string;
}
/**
 * Request parameters for apiV1EmailwebhooksTestPost operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksTestPostRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksTestPostRequest {
    /**
     *
     * @type {TestEmailWebhookCommand}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksTestPost
     */
    readonly testEmailWebhookCommand?: TestEmailWebhookCommand;
}
/**
 * EmailWebhooksApi - object-oriented interface
 * @export
 * @class EmailWebhooksApi
 * @extends {BaseAPI}
 */
export declare class EmailWebhooksApi extends BaseAPI {
    /**
     *
     * @summary Receive email webhooks events
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    apiV1EmailwebhooksInboundPost(options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<object, any>>;
    /**
     *
     * @summary Get email records. (from an week ago as default) (Auth policies: RequireDoctorRole)
     * @param {EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    apiV1EmailwebhooksRecordsGet(requestParameters?: EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<EmailRecordsModel, any>>;
    /**
     *
     * @summary Get email record by id with events. (Auth policies: RequireDoctorRole)
     * @param {EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    apiV1EmailwebhooksRecordsRecordIdGet(requestParameters: EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<EmailRecordModel, any>>;
    /**
     *
     * @summary Sending test email that follows email webhook steps. (Auth policies: RequireDoctorRole)
     * @param {EmailWebhooksApiApiV1EmailwebhooksTestPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    apiV1EmailwebhooksTestPost(requestParameters?: EmailWebhooksApiApiV1EmailwebhooksTestPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TestEmailModel, any>>;
}
//# sourceMappingURL=email-webhooks-api.d.ts.map