/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreatePatientManagerCommand } from '../models';
import { Gender } from '../models';
import { PatientManagerModel } from '../models';
import { PatientManagersModel } from '../models';
import { UpdatePatientManagerCommand } from '../models';
/**
 * PatientManagersApi - axios parameter creator
 * @export
 */
export declare const PatientManagersApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersGet: (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdDelete: (patientManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdGet: (patientManagerId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdPut: (patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdReactivatePut: (patientManagerId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a PatientManager. (Auth roles: Admin,Manager)
     * @param {CreatePatientManagerCommand} [createPatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPost: (createPatientManagerCommand?: CreatePatientManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * PatientManagersApi - functional programming interface
 * @export
 */
export declare const PatientManagersApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagersModel>>;
    /**
     *
     * @summary Delete PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdDelete(patientManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdGet(patientManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>>;
    /**
     *
     * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdPut(patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>>;
    /**
     *
     * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create a PatientManager. (Auth roles: Admin,Manager)
     * @param {CreatePatientManagerCommand} [createPatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPost(createPatientManagerCommand?: CreatePatientManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientManagerModel>>;
};
/**
 * PatientManagersApi - factory interface
 * @export
 */
export declare const PatientManagersApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PatientManagersModel>;
    /**
     *
     * @summary Delete PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdDelete(patientManagerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdGet(patientManagerId: string, options?: any): AxiosPromise<PatientManagerModel>;
    /**
     *
     * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {string} patientManagerId
     * @param {UpdatePatientManagerCommand} [updatePatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdPut(patientManagerId: string, updatePatientManagerCommand?: UpdatePatientManagerCommand, options?: any): AxiosPromise<PatientManagerModel>;
    /**
     *
     * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
     * @param {string} patientManagerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPatientManagerIdReactivatePut(patientManagerId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create a PatientManager. (Auth roles: Admin,Manager)
     * @param {CreatePatientManagerCommand} [createPatientManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientmanagersPost(createPatientManagerCommand?: CreatePatientManagerCommand, options?: any): AxiosPromise<PatientManagerModel>;
};
/**
 * Request parameters for apiV1PatientmanagersGet operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersGetRequest
 */
export interface PatientManagersApiApiV1PatientmanagersGetRequest {
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly fullname?: string;
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly email?: string;
    /**
     *
     * @type {Gender}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly gender?: Gender;
    /**
     *
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly dateOfBirth?: Date;
    /**
     *
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly created?: Date;
    /**
     *
     * @type {boolean}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof PatientManagersApiApiV1PatientmanagersGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdDelete operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdDelete
     */
    readonly patientManagerId: string;
    /**
     *
     * @type {boolean}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdGet operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdGet
     */
    readonly patientManagerId: string;
}
/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdPut operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdPut
     */
    readonly patientManagerId: string;
    /**
     *
     * @type {UpdatePatientManagerCommand}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdPut
     */
    readonly updatePatientManagerCommand?: UpdatePatientManagerCommand;
}
/**
 * Request parameters for apiV1PatientmanagersPatientManagerIdReactivatePut operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePut
     */
    readonly patientManagerId: string;
}
/**
 * Request parameters for apiV1PatientmanagersPost operation in PatientManagersApi.
 * @export
 * @interface PatientManagersApiApiV1PatientmanagersPostRequest
 */
export interface PatientManagersApiApiV1PatientmanagersPostRequest {
    /**
     *
     * @type {CreatePatientManagerCommand}
     * @memberof PatientManagersApiApiV1PatientmanagersPost
     */
    readonly createPatientManagerCommand?: CreatePatientManagerCommand;
}
/**
 * PatientManagersApi - object-oriented interface
 * @export
 * @class PatientManagersApi
 * @extends {BaseAPI}
 */
export declare class PatientManagersApi extends BaseAPI {
    /**
     *
     * @summary Get all PatientManagers. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersGet(requestParameters?: PatientManagersApiApiV1PatientmanagersGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientManagersModel, any>>;
    /**
     *
     * @summary Delete PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersPatientManagerIdDelete(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersPatientManagerIdGet(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientManagerModel, any>>;
    /**
     *
     * @summary Update PatientManager. (Auth roles: Admin,Manager,PatientManager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersPatientManagerIdPut(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientManagerModel, any>>;
    /**
     *
     * @summary Reactivate PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersPatientManagerIdReactivatePut(requestParameters: PatientManagersApiApiV1PatientmanagersPatientManagerIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create a PatientManager. (Auth roles: Admin,Manager)
     * @param {PatientManagersApiApiV1PatientmanagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientManagersApi
     */
    apiV1PatientmanagersPost(requestParameters?: PatientManagersApiApiV1PatientmanagersPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientManagerModel, any>>;
}
//# sourceMappingURL=patient-managers-api.d.ts.map