/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateServiceCategoryCommand } from '../models';
import { ServiceCategoriesModel } from '../models';
import { ServiceCategoryModel } from '../models';
import { UpdateServiceCategoryCommand } from '../models';
/**
 * ServicesCategoriesApi - axios parameter creator
 * @export
 */
export declare const ServicesCategoriesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all ServiceCategories. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesGet: (id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary (Auth policies: RequireManagerRole)
     * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesPost: (createServiceCategoryCommand?: CreateServiceCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete ServiceCategory. (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdDelete: (serviceCategoryId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get ServiceCategory. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdGet: (serviceCategoryId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update ServiceCategory (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdPut: (serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ServicesCategoriesApi - functional programming interface
 * @export
 */
export declare const ServicesCategoriesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all ServiceCategories. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoriesModel>>;
    /**
     *
     * @summary (Auth policies: RequireManagerRole)
     * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesPost(createServiceCategoryCommand?: CreateServiceCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>>;
    /**
     *
     * @summary Delete ServiceCategory. (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get ServiceCategory. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>>;
    /**
     *
     * @summary Update ServiceCategory (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>>;
};
/**
 * ServicesCategoriesApi - factory interface
 * @export
 */
export declare const ServicesCategoriesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all ServiceCategories. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [name]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ServiceCategoriesModel>;
    /**
     *
     * @summary (Auth policies: RequireManagerRole)
     * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesPost(createServiceCategoryCommand?: CreateServiceCategoryCommand, options?: any): AxiosPromise<ServiceCategoryModel>;
    /**
     *
     * @summary Delete ServiceCategory. (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get ServiceCategory. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} serviceCategoryId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId: string, options?: any): AxiosPromise<ServiceCategoryModel>;
    /**
     *
     * @summary Update ServiceCategory (Auth policies: RequireManagerRole)
     * @param {string} serviceCategoryId
     * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options?: any): AxiosPromise<ServiceCategoryModel>;
};
/**
 * Request parameters for apiV1ServicescategoriesGet operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesGetRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly name?: string;
    /**
     *
     * @type {number}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ServicescategoriesPost operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesPostRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesPostRequest {
    /**
     *
     * @type {CreateServiceCategoryCommand}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesPost
     */
    readonly createServiceCategoryCommand?: CreateServiceCategoryCommand;
}
/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdDelete operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDelete
     */
    readonly serviceCategoryId: string;
}
/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdGet operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGet
     */
    readonly serviceCategoryId: string;
}
/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdPut operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPut
     */
    readonly serviceCategoryId: string;
    /**
     *
     * @type {UpdateServiceCategoryCommand}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPut
     */
    readonly updateServiceCategoryCommand?: UpdateServiceCategoryCommand;
}
/**
 * ServicesCategoriesApi - object-oriented interface
 * @export
 * @class ServicesCategoriesApi
 * @extends {BaseAPI}
 */
export declare class ServicesCategoriesApi extends BaseAPI {
    /**
     *
     * @summary Get all ServiceCategories. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {ServicesCategoriesApiApiV1ServicescategoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    apiV1ServicescategoriesGet(requestParameters?: ServicesCategoriesApiApiV1ServicescategoriesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceCategoriesModel, any>>;
    /**
     *
     * @summary (Auth policies: RequireManagerRole)
     * @param {ServicesCategoriesApiApiV1ServicescategoriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    apiV1ServicescategoriesPost(requestParameters?: ServicesCategoriesApiApiV1ServicescategoriesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceCategoryModel, any>>;
    /**
     *
     * @summary Delete ServiceCategory. (Auth policies: RequireManagerRole)
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    apiV1ServicescategoriesServiceCategoryIdDelete(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get ServiceCategory. (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    apiV1ServicescategoriesServiceCategoryIdGet(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceCategoryModel, any>>;
    /**
     *
     * @summary Update ServiceCategory (Auth policies: RequireManagerRole)
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    apiV1ServicescategoriesServiceCategoryIdPut(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ServiceCategoryModel, any>>;
}
//# sourceMappingURL=services-categories-api.d.ts.map