/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateSurveyFormCommand } from '../models';
import { SetHospitalIntoSurveyFormCommand } from '../models';
import { SurveyFormAffiliationsModel } from '../models';
import { SurveyFormModel } from '../models';
import { SurveyFormStatus } from '../models';
import { SurveyFormsModel } from '../models';
import { UpdateSurveyFormCommand } from '../models';
/**
 * SurveyFormsApi - axios parameter creator
 * @export
 */
export declare const SurveyFormsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get survey forms (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [isShared]
     * @param {SurveyFormStatus} [status]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsGet: (id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create survey form (Auth policies: RequireDoctorRole)
     * @param {CreateSurveyFormCommand} [createSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsPost: (createSurveyFormCommand?: CreateSurveyFormCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdDelete: (surveyFormId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdGet: (surveyFormId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Remove hospital from surveyFormAffiliations (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete: (surveyFormId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add hospital into surveyFormAffiliation. (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost: (surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update survey form (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdPut: (surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate surveyForm (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdReactivatePut: (surveyFormId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get surveyFormAffiliations (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet: (surveyFormId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * SurveyFormsApi - functional programming interface
 * @export
 */
export declare const SurveyFormsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get survey forms (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [isShared]
     * @param {SurveyFormStatus} [status]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsGet(id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormsModel>>;
    /**
     *
     * @summary Create survey form (Auth policies: RequireDoctorRole)
     * @param {CreateSurveyFormCommand} [createSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsPost(createSurveyFormCommand?: CreateSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>>;
    /**
     *
     * @summary Delete survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdDelete(surveyFormId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdGet(surveyFormId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>>;
    /**
     *
     * @summary Remove hospital from surveyFormAffiliations (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Add hospital into surveyFormAffiliation. (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Update survey form (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdPut(surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>>;
    /**
     *
     * @summary Reactivate surveyForm (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get surveyFormAffiliations (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet(surveyFormId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormAffiliationsModel>>;
};
/**
 * SurveyFormsApi - factory interface
 * @export
 */
export declare const SurveyFormsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get survey forms (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [isShared]
     * @param {SurveyFormStatus} [status]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsGet(id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SurveyFormsModel>;
    /**
     *
     * @summary Create survey form (Auth policies: RequireDoctorRole)
     * @param {CreateSurveyFormCommand} [createSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsPost(createSurveyFormCommand?: CreateSurveyFormCommand, options?: any): AxiosPromise<SurveyFormModel>;
    /**
     *
     * @summary Delete survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdDelete(surveyFormId: string, languageCode?: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get survey form by Id (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdGet(surveyFormId: string, languageCode?: string, hospitalId?: string, options?: any): AxiosPromise<SurveyFormModel>;
    /**
     *
     * @summary Remove hospital from surveyFormAffiliations (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId: string, hospitalId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Add hospital into surveyFormAffiliation. (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {string} hospitalId
     * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Update survey form (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdPut(surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options?: any): AxiosPromise<SurveyFormModel>;
    /**
     *
     * @summary Reactivate surveyForm (Auth policies: RequireDoctorRole)
     * @param {string} surveyFormId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get surveyFormAffiliations (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {string} surveyFormId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet(surveyFormId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SurveyFormAffiliationsModel>;
};
/**
 * Request parameters for apiV1SurveyformsGet operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsGetRequest
 */
export interface SurveyFormsApiApiV1SurveyformsGetRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly isShared?: boolean;
    /**
     *
     * @type {SurveyFormStatus}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly status?: SurveyFormStatus;
    /**
     *
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1SurveyformsPost operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsPostRequest
 */
export interface SurveyFormsApiApiV1SurveyformsPostRequest {
    /**
     *
     * @type {CreateSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsPost
     */
    readonly createSurveyFormCommand?: CreateSurveyFormCommand;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdDelete operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdGet operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly hospitalId?: string;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string;
    /**
     *
     * @type {SetHospitalIntoSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdPut operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdPut
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {UpdateSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdPut
     */
    readonly updateSurveyFormCommand?: UpdateSurveyFormCommand;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdReactivatePut operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePut
     */
    readonly surveyFormId: string;
}
/**
 * Request parameters for apiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGetRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGetRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet
     */
    readonly surveyFormId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * SurveyFormsApi - object-oriented interface
 * @export
 * @class SurveyFormsApi
 * @extends {BaseAPI}
 */
export declare class SurveyFormsApi extends BaseAPI {
    /**
     *
     * @summary Get survey forms (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {SurveyFormsApiApiV1SurveyformsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsGet(requestParameters?: SurveyFormsApiApiV1SurveyformsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormsModel, any>>;
    /**
     *
     * @summary Create survey form (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsPost(requestParameters?: SurveyFormsApiApiV1SurveyformsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormModel, any>>;
    /**
     *
     * @summary Delete survey form by Id (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdDelete(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get survey form by Id (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdGet(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormModel, any>>;
    /**
     *
     * @summary Remove hospital from surveyFormAffiliations (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Add hospital into surveyFormAffiliation. (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Update survey form (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdPut(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormModel, any>>;
    /**
     *
     * @summary Reactivate surveyForm (Auth policies: RequireDoctorRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdReactivatePut(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get surveyFormAffiliations (Auth policies: RequireDoctorOrContentManagerRole)
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    apiV1SurveyformsSurveyFormIdSurveyformaffiliationsGet(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdSurveyformaffiliationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyFormAffiliationsModel, any>>;
}
//# sourceMappingURL=survey-forms-api.d.ts.map