/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateTagCommand } from '../models';
import { StringFilterTypes } from '../models';
import { TagModel } from '../models';
import { TagsModel } from '../models';
/**
 * TagsApi - axios parameter creator
 * @export
 */
export declare const TagsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Tags. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} [tagId]
     * @param {StringFilterTypes} [filterType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsGet: (tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {CreateTagCommand} [createTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsPost: (createTagCommand?: CreateTagCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdDelete: (tagId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {boolean} [releatedTags]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdGet: (tagId: string, releatedTags?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * TagsApi - functional programming interface
 * @export
 */
export declare const TagsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Tags. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} [tagId]
     * @param {StringFilterTypes} [filterType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsGet(tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagsModel>>;
    /**
     *
     * @summary Create a Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {CreateTagCommand} [createTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsPost(createTagCommand?: CreateTagCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagModel>>;
    /**
     *
     * @summary Delete Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdDelete(tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {boolean} [releatedTags]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdGet(tagId: string, releatedTags?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagModel>>;
};
/**
 * TagsApi - factory interface
 * @export
 */
export declare const TagsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all Tags. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} [tagId]
     * @param {StringFilterTypes} [filterType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsGet(tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<TagsModel>;
    /**
     *
     * @summary Create a Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {CreateTagCommand} [createTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsPost(createTagCommand?: CreateTagCommand, options?: any): AxiosPromise<TagModel>;
    /**
     *
     * @summary Delete Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdDelete(tagId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {string} tagId
     * @param {boolean} [releatedTags]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TagsTagIdGet(tagId: string, releatedTags?: boolean, options?: any): AxiosPromise<TagModel>;
};
/**
 * Request parameters for apiV1TagsGet operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsGetRequest
 */
export interface TagsApiApiV1TagsGetRequest {
    /**
     *
     * @type {string}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly tagId?: string;
    /**
     *
     * @type {StringFilterTypes}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly filterType?: StringFilterTypes;
    /**
     *
     * @type {number}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1TagsPost operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsPostRequest
 */
export interface TagsApiApiV1TagsPostRequest {
    /**
     *
     * @type {CreateTagCommand}
     * @memberof TagsApiApiV1TagsPost
     */
    readonly createTagCommand?: CreateTagCommand;
}
/**
 * Request parameters for apiV1TagsTagIdDelete operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsTagIdDeleteRequest
 */
export interface TagsApiApiV1TagsTagIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof TagsApiApiV1TagsTagIdDelete
     */
    readonly tagId: string;
}
/**
 * Request parameters for apiV1TagsTagIdGet operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsTagIdGetRequest
 */
export interface TagsApiApiV1TagsTagIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof TagsApiApiV1TagsTagIdGet
     */
    readonly tagId: string;
    /**
     *
     * @type {boolean}
     * @memberof TagsApiApiV1TagsTagIdGet
     */
    readonly releatedTags?: boolean;
}
/**
 * TagsApi - object-oriented interface
 * @export
 * @class TagsApi
 * @extends {BaseAPI}
 */
export declare class TagsApi extends BaseAPI {
    /**
     *
     * @summary Get all Tags. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TagsApiApiV1TagsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    apiV1TagsGet(requestParameters?: TagsApiApiV1TagsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TagsModel, any>>;
    /**
     *
     * @summary Create a Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TagsApiApiV1TagsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    apiV1TagsPost(requestParameters?: TagsApiApiV1TagsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TagModel, any>>;
    /**
     *
     * @summary Delete Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TagsApiApiV1TagsTagIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    apiV1TagsTagIdDelete(requestParameters: TagsApiApiV1TagsTagIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Tag. (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TagsApiApiV1TagsTagIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    apiV1TagsTagIdGet(requestParameters: TagsApiApiV1TagsTagIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TagModel, any>>;
}
//# sourceMappingURL=tags-api.d.ts.map