/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { TranslateCommand } from '../models';
import { TranslationPersonaType } from '../models';
/**
 * TranslationApi - axios parameter creator
 * @export
 */
export declare const TranslationApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get translation persona instruction prompt (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslationPersonaType} [personaType]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationPersonaGet: (personaType?: TranslationPersonaType, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslateCommand} [translateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationTranslatePost: (translateCommand?: TranslateCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * TranslationApi - functional programming interface
 * @export
 */
export declare const TranslationApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get translation persona instruction prompt (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslationPersonaType} [personaType]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationPersonaGet(personaType?: TranslationPersonaType, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Translate (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslateCommand} [translateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationTranslatePost(translateCommand?: TranslateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
};
/**
 * TranslationApi - factory interface
 * @export
 */
export declare const TranslationApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get translation persona instruction prompt (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslationPersonaType} [personaType]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationPersonaGet(personaType?: TranslationPersonaType, options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Translate (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslateCommand} [translateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1TranslationTranslatePost(translateCommand?: TranslateCommand, options?: any): AxiosPromise<string>;
};
/**
 * Request parameters for apiV1TranslationPersonaGet operation in TranslationApi.
 * @export
 * @interface TranslationApiApiV1TranslationPersonaGetRequest
 */
export interface TranslationApiApiV1TranslationPersonaGetRequest {
    /**
     *
     * @type {TranslationPersonaType}
     * @memberof TranslationApiApiV1TranslationPersonaGet
     */
    readonly personaType?: TranslationPersonaType;
}
/**
 * Request parameters for apiV1TranslationTranslatePost operation in TranslationApi.
 * @export
 * @interface TranslationApiApiV1TranslationTranslatePostRequest
 */
export interface TranslationApiApiV1TranslationTranslatePostRequest {
    /**
     *
     * @type {TranslateCommand}
     * @memberof TranslationApiApiV1TranslationTranslatePost
     */
    readonly translateCommand?: TranslateCommand;
}
/**
 * TranslationApi - object-oriented interface
 * @export
 * @class TranslationApi
 * @extends {BaseAPI}
 */
export declare class TranslationApi extends BaseAPI {
    /**
     *
     * @summary Get translation persona instruction prompt (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslationApiApiV1TranslationPersonaGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TranslationApi
     */
    apiV1TranslationPersonaGet(requestParameters?: TranslationApiApiV1TranslationPersonaGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Translate (Auth roles: Admin,Manager,ContentManager,PatientManager,LocalManager,Doctor)
     * @param {TranslationApiApiV1TranslationTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TranslationApi
     */
    apiV1TranslationTranslatePost(requestParameters?: TranslationApiApiV1TranslationTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
}
//# sourceMappingURL=translation-api.d.ts.map