/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateUserCommand } from '../models';
import { GeneralUserModel } from '../models';
import { GeneralUsersModel } from '../models';
import { UpdateUserCommand } from '../models';
/**
 * UsersApi - axios parameter creator
 * @export
 */
export declare const UsersApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get users (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [role]
     * @param {string} [hospitalId]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersGet: (name?: string, email?: string, role?: string, hospitalId?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdDelete: (id: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get user by id (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdGet: (id: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsDelete: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsPost: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {UpdateUserCommand} [updateUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdPut: (id: string, updateUserCommand?: UpdateUserCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdReactivatePut: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create user (Auth policies: RequireLocalManagerRole)
     * @param {CreateUserCommand} [createUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersPost: (createUserCommand?: CreateUserCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * UsersApi - functional programming interface
 * @export
 */
export declare const UsersApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get users (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [role]
     * @param {string} [hospitalId]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersGet(name?: string, email?: string, role?: string, hospitalId?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralUsersModel>>;
    /**
     *
     * @summary Delete user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdDelete(id: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get user by id (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdGet(id: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralUserModel>>;
    /**
     *
     * @summary Delete identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsDelete(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsPost(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {UpdateUserCommand} [updateUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdPut(id: string, updateUserCommand?: UpdateUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralUserModel>>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdReactivatePut(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create user (Auth policies: RequireLocalManagerRole)
     * @param {CreateUserCommand} [createUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersPost(createUserCommand?: CreateUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeneralUserModel>>;
};
/**
 * UsersApi - factory interface
 * @export
 */
export declare const UsersApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get users (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} [name]
     * @param {string} [email]
     * @param {string} [role]
     * @param {string} [hospitalId]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersGet(name?: string, email?: string, role?: string, hospitalId?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<GeneralUsersModel>;
    /**
     *
     * @summary Delete user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdDelete(id: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get user by id (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdGet(id: string, languageCode?: string, options?: any): AxiosPromise<GeneralUserModel>;
    /**
     *
     * @summary Delete identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsDelete(id: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create identity account (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdIdentityaccountsPost(id: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {UpdateUserCommand} [updateUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdPut(id: string, updateUserCommand?: UpdateUserCommand, options?: any): AxiosPromise<GeneralUserModel>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersIdReactivatePut(id: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create user (Auth policies: RequireLocalManagerRole)
     * @param {CreateUserCommand} [createUserCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1UsersPost(createUserCommand?: CreateUserCommand, options?: any): AxiosPromise<GeneralUserModel>;
};
/**
 * Request parameters for apiV1UsersGet operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersGetRequest
 */
export interface UsersApiApiV1UsersGetRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly email?: string;
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly role?: string;
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {boolean}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof UsersApiApiV1UsersGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1UsersIdDelete operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdDeleteRequest
 */
export interface UsersApiApiV1UsersIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdDelete
     */
    readonly id: string;
    /**
     *
     * @type {boolean}
     * @memberof UsersApiApiV1UsersIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1UsersIdGet operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdGetRequest
 */
export interface UsersApiApiV1UsersIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdGet
     */
    readonly id: string;
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1UsersIdIdentityaccountsDelete operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdIdentityaccountsDeleteRequest
 */
export interface UsersApiApiV1UsersIdIdentityaccountsDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdIdentityaccountsDelete
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1UsersIdIdentityaccountsPost operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdIdentityaccountsPostRequest
 */
export interface UsersApiApiV1UsersIdIdentityaccountsPostRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdIdentityaccountsPost
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1UsersIdPut operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdPutRequest
 */
export interface UsersApiApiV1UsersIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdPut
     */
    readonly id: string;
    /**
     *
     * @type {UpdateUserCommand}
     * @memberof UsersApiApiV1UsersIdPut
     */
    readonly updateUserCommand?: UpdateUserCommand;
}
/**
 * Request parameters for apiV1UsersIdReactivatePut operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersIdReactivatePutRequest
 */
export interface UsersApiApiV1UsersIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof UsersApiApiV1UsersIdReactivatePut
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1UsersPost operation in UsersApi.
 * @export
 * @interface UsersApiApiV1UsersPostRequest
 */
export interface UsersApiApiV1UsersPostRequest {
    /**
     *
     * @type {CreateUserCommand}
     * @memberof UsersApiApiV1UsersPost
     */
    readonly createUserCommand?: CreateUserCommand;
}
/**
 * UsersApi - object-oriented interface
 * @export
 * @class UsersApi
 * @extends {BaseAPI}
 */
export declare class UsersApi extends BaseAPI {
    /**
     *
     * @summary Get users (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {UsersApiApiV1UsersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersGet(requestParameters?: UsersApiApiV1UsersGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GeneralUsersModel, any>>;
    /**
     *
     * @summary Delete user (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdDelete(requestParameters: UsersApiApiV1UsersIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get user by id (Auth roles: Admin,Manager,PatientManager,LocalManager,Doctor)
     * @param {UsersApiApiV1UsersIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdGet(requestParameters: UsersApiApiV1UsersIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GeneralUserModel, any>>;
    /**
     *
     * @summary Delete identity account (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersIdIdentityaccountsDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdIdentityaccountsDelete(requestParameters: UsersApiApiV1UsersIdIdentityaccountsDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create identity account (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersIdIdentityaccountsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdIdentityaccountsPost(requestParameters: UsersApiApiV1UsersIdIdentityaccountsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdPut(requestParameters: UsersApiApiV1UsersIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GeneralUserModel, any>>;
    /**
     *
     * @summary Reactivate user (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersIdReactivatePut(requestParameters: UsersApiApiV1UsersIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create user (Auth policies: RequireLocalManagerRole)
     * @param {UsersApiApiV1UsersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    apiV1UsersPost(requestParameters?: UsersApiApiV1UsersPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GeneralUserModel, any>>;
}
//# sourceMappingURL=users-api.d.ts.map